/* Copyright (c) 1997 by Juliusz Chroboczek */

#include <sys/types.h>
#include <unistd.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include "types.h"
#include "proto.h"

void 
*mymalloc(size_t size)
{
  void *p;
  if((p=malloc(size))==NULL)
    error("Unable to allocate memory\n");
  return p;
}

off_t
surely_lseek(int fildes, off_t offset, int whence)
{
  off_t result;
  if((result=lseek(fildes,offset,whence))<0)
    error("Bad TTF file");
  return result;
}

void
error(char *string)
{
  fprintf(stderr,"%s\n",string);
  exit(3);
  /*NOTREACHED*/
}

void
syserror(char *string)
{
  perror(string);
  exit(3);
  /*NOTREACHED*/
}

ssize_t 
surely_read(int fildes, void *buf, size_t nbyte)
{
  ssize_t n;
  if((n=read(fildes,buf,nbyte))<nbyte)
    error("Bad TTF file");
  return n;
}

char *
unistrncpy(char *dst, char *str, size_t length)
{
  int i,j;

  for(i=j=0; i<length; i+=2)
    if(str[i]==0)
      dst[j++]=str[i+1];
  dst[j]='\0';
  return dst;
}

void
fputpss(char *s, FILE *stream)
{
  while(*s) {
    if((*s&0200)==0 && *s>=040 && *s!='(' && *s!=')')
      putc(*s,stream);
    else
      fprintf(stream,"\\%03o",(unsigned char)*s);
    s++;
  }
}

